#pragma semicolon 1
#pragma newdecls required

#include <sdktools_functions>
#include <vip_core>
#include <multicolors>

bool
	bEnable;

int
	iWeaponCount[MAXPLAYERS+1][24],
	iCount;

static const char sWeaponList[][] = 
{
	"weapon_glock",
	"weapon_usp",
	"weapon_p228",
	"weapon_deagle",
	"weapon_elite",
	"weapon_fiveseven",
	"weapon_m3",
	"weapon_xm1014",
	"weapon_mac10",
	"weapon_tmp",
	"weapon_mp5navy",
	"weapon_ump45",
	"weapon_famas",
	"weapon_ak47",
	"weapon_m4a1",
	"weapon_scout",
	"weapon_sg550",
	"weapon_aug",
	"weapon_awp",
	"weapon_g3sg1",
	"weapon_sg552",
	"weapon_m249",
	"weapon_p90",
	"weapon_galil"
};

static const char g_sFeature[] = "give_weapons";

public Plugin myinfo = 
{
	name = "[ViP Core] Fast give weapon/Быстрая смена оружия",
	author = "Nek.'a 2x2 | ggwp.site ",
	description = "Быстрая смена оружия",
	version = "1.0.2",
	url = "https://ggwp.site/"
};

public void OnPluginStart()
{
	LoadTranslations("vip_weapons_give.phrases");
	
	ConVar cvar;
	cvar = CreateConVar("sm_vip_wgive_enabled", "1", "Включить/выключить плагин", _, true, _, true, 1.0);
	cvar.AddChangeHook(CVarChanged_Enable);
	bEnable = cvar.BoolValue;

	cvar = CreateConVar("sm_vip_wgive_count", "2", "Сколько максимум каждого вида оружия можно взять за раунд", _, true, 0.0, true, 9999.0);
	cvar.AddChangeHook(CVarChanged_Count);
	iCount = cvar.IntValue;
	
	HookEvent("round_start", Event_OnStart);
	
	RegConsoleCmd("vip_give", Cmd, "");
	RegConsoleCmd("vip_weapon", Cmd, "");

	for(int i = 1; i < MaxClients; i++) for(int d; d < 24; d++) iWeaponCount[i][d] = 0;
	if(VIP_IsVIPLoaded()) VIP_OnVIPLoaded();

	AutoExecConfig(true, "give_weapons", "vip");
}

public void CVarChanged_Enable(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	bEnable	= cvar.BoolValue;
}

public void CVarChanged_Count(ConVar cvar, const char[] oldValue, const char[] newValue)
{
	iCount = cvar.IntValue;
}

public void OnPluginEnd()
{
	if(CanTestFeatures() && GetFeatureStatus(FeatureType_Native, "VIP_UnregisterFeature") == FeatureStatus_Available)
		VIP_UnregisterFeature(g_sFeature);
}

public void VIP_OnVIPLoaded()
{
	VIP_RegisterFeature(g_sFeature, BOOL);
}

public Action Event_OnStart(Handle hEvent, const char[] sName, bool bDontBroadcast)
{
	for(int i = 1; i < MaxClients; i++) for(int d; d < 24; d++) iWeaponCount[i][d] = 0;
}

public Action Cmd(int iClient, any args)
{
	if(!bEnable)
		return Plugin_Continue;
		
	if(!iClient || !IsPlayerAlive(iClient))
		return Plugin_Continue;
		
	if(!VIP_IsClientVIP(iClient))
		return Plugin_Continue;
	
	if(!VIP_IsClientFeatureUse(iClient, g_sFeature))
		return Plugin_Continue;
	
	char sWeapon[4][16];
	int iIndex[3];
	iIndex[0] = GetPlayerWeaponSlot(iClient, 0);
	iIndex[1] = GetPlayerWeaponSlot(iClient, 1);
	
	GetCmdArg(1, sWeapon[0], sizeof (sWeapon[]));
	
	Format(sWeapon[2], sizeof(sWeapon[]), "weapon_%s", sWeapon[0]);
	GetClientWeapon(iClient, sWeapon[1], sizeof (sWeapon[]));

	bool bCheckItem;
	int iItemsNum = sizeof(sWeaponList);
	
	for(int i; i < 2; i++)
	{
		iIndex[2] = GetPlayerWeaponSlot(iClient, i);
		if(iIndex[2] != -1) GetEntityClassname(iIndex[2], sWeapon[3], sizeof(sWeapon[]));
		
		if(StrEqual(sWeapon[3], sWeapon[2], true))
			return Plugin_Continue;
	}
	
	for(int i; i < iItemsNum; i++) if(!bCheckItem)
	{
		if(StrEqual(sWeaponList[i], sWeapon[2], true))		//Проверка есть ли оружие в списке
		{
			if(iWeaponCount[iClient][i] < iCount)
			{
				if(i <= 5 && iIndex[1] != -1)
					RemovePlayerItem(iClient, iIndex[1]);		//Пистолеты

				else if(i > 5 && iIndex[0] != -1)
					RemovePlayerItem(iClient, iIndex[0]);		//Автоматы
				
				GivePlayerItem(iClient, sWeapon[2]);
				iWeaponCount[iClient][i]++;
				bCheckItem = true;
				return Plugin_Handled;
			}
			else
				CPrintToChat(iClient, "%t", "Tag", "Limitation", sWeapon[0], iWeaponCount[iClient][i], iCount);
		}
	}
	return Plugin_Continue;
}